;;; Functions and procedured 

;;; Computing Fibonacci numbers -- iterative version

define fibi(n) -> f;
  lvars i, n, f = 1, fo = 1;
  for i from 2 to n do
    (fo + f, f ) -> (f, fo);
  endfor;
enddefine;


;;; Computing GCD -- iterative version

define my_gcd(k, l) -> r;
  lvars k , l, r = l;
  abs(k) -> k;
  abs(l) -> l;
  if k < l then (k, l) -> (l, k) endif;
  while l /= 0 do
    (l, k rem l) -> (k, l)
  endwhile;
  k -> r;
enddefine;

;;; Identity gcd(Fib(n-1), Fib(k-1)) = Fib(gcd(n, k)-1)
printf(fibi(9*35-1), 'fibi(9*35-1) = %p\n');
printf(fibi(2*35-1), 'fibi(2*35-1) = %p\n');
printf(my_gcd(fibi(2*35-1), fibi(9*35-1)),
      'my_gcd(fibi(2*35-1), fibi(9*35-1)) = %p\n');
printf(fibi(34), 'fibi(34) = %p\n');

;;; Printing one dimensional array
define printarr(a);
  lvars a, b = boundslist(a), i, i0 = b(1), i1 = b(2);
  if length(b) /= 2 then
    mishap(a, 1, 'One dimensional array needed')
  endif;
  printf('<%% ');
  for i from i0 to i1 do 
    printf(a(i), '%p' <> if i = i1 then '' else ', ' endif);
    if i > i0 and (i - i0) rem 10 = 0 then printf('\n') endif;
  endfor;
  printf(' %%>\n');
enddefine;

;;; Applying a function to all elements of an array
define apparr(a, f) -> na;
  lvars a, f, na, b = boundslist(a), i, i0 = b(1), i1 = b(2);
  if length(b) /= 2 then 
    mishap(a, 1, 'One dimensional array needed')
  endif;
  newarray(b) -> na;
  for i from i0 to i1 do f(a(i)) -> na(i) endfor;
enddefine;

;;; Initialize 'arr' to be an array with indices ranging from
;;; 1 to 5
lvars arr = newarray([1 5]);


;;; Fill the array with third powers
lvars i;
for i from 1 to 5 do
  i * i * i -> arr(i);
endfor;

;;; print
printf('elements of arr: ');
printarr(arr);

;;; print a table of Fibonacci numbers
printf('Corresponding Fibonacci numbers: ');
printarr(apparr(arr, fibi));

