/*
  Example of a generator (of permutations)
*/

define genperms(k, p);
   lvars k, t, i;
   for i from 1 to k do i; endfor;
   consvector(k) -> t;
   define lconstant genperms1(j);
   lvars i1;
   if j = 1 then
     p(t);
   else
     for i1 from 1 to j do
       (t(i1), t(j)) -> (t(j), t(i1));
       genperms1(j - 1);
       (t(i1), t(j)) -> (t(j), t(i1));
     endfor;
   endif;      
   enddefine;
   genperms1(k);
enddefine;

/*
  Procedure get_perm_iterator.
  Goal: returns a generator of permutions of the set 1..k, that is
       a procedure which when called return one (next) permutation
       or false. Reapeatedly calling the generator until it
       returns false will give all permutions of the set 1..k.

*/

define get_perm_iterator(k);
  lvars k, cp;
  define lconstant give_perm(t);
    lvars t;
    suspend(copy(t), 1);
  enddefine;
  define lconstant start_perms();
    suspend(0);
    genperms(k, give_perm);
    ksuspend(false, 1);
  enddefine;
  lvars pproc = consproc(0, start_perms);
  runproc(0, pproc);
  procedure();
    runproc(0, pproc);
  endprocedure;
enddefine;

vars perm_iterator = get_perm_iterator(3), perm;

while perm_iterator() ->> perm do
  perm ==>
endwhile;
